=== debian/changelog ===
mummy (1.0.2-5) unstable; urgency=low

  * Bump Std-Vers to 3.9.3, no changes needed
  * Use my @d.o alias, remove DMUA flag
  * Remove SONAME in C# module, breaks debian policy. Closes: #671845

 -- Mathieu Malaterre <malat@debian.org>  Mon, 07 May 2012 17:27:30 +0200

mummy (1.0.2-4) unstable; urgency=low

  [ Iain Lane ]
  * Use Debian's default compiler /usr/bin/mono-csc. Closes: #652976

  [ Mathieu Malaterre ]
  * Use dh_installdocs for docs
  * Use SVG output for graph
  * Remove *.md5 from doxygen output

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Wed, 28 Dec 2011 16:04:30 +0100

mummy (1.0.2-3) unstable; urgency=low

  * Fix failure on buildd since -indep is ran anyway

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Wed, 28 Dec 2011 11:28:11 +0100

mummy (1.0.2-2) unstable; urgency=low

  * Update mummy man page.
  * Remove quilt B-D.
  * Properly set documentation variable in d/rules.

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Tue, 27 Dec 2011 17:24:27 +0100

mummy (1.0.2-1) unstable; urgency=low

  * Initial release (Closes: #611789)

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Wed, 19 Oct 2011 15:38:05 +0200
