=== debian/control ===
Source: mummy
Section: devel
Priority: extra
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Mathieu Malaterre <malat@debian.org>
Build-Depends: debhelper (>= 8), cmake (>= 2.8.2),
 mono-devel, cli-common-dev (>= 0.5.7), libcableswig-dev, libgccxml-dev, libexpat-dev
Build-Depends-Indep: doxygen (>= 1.6.2), graphviz
Standards-Version: 3.9.3
Homepage: http://www.kitware.com/products/avdownload.php
Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/mummy/trunk
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/mummy/trunk/

Package: mummy
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: gccxml
Description: command line executable that generates C# wrappers from gccxml output
 mummy is a command line executable that generates C# wrappers from gccxml
 output. A C# class is generated to wrap the wrappable class named in the gccxml
 output. Settings to control the wrapping are given inline directly in the class
 header file or in the MummySettings.xml input file.

Package: libkitware-mummy-runtime1.0-cil
Architecture: any
Section: cli-mono
Depends: ${shlibs:Depends}, ${misc:Depends}, ${cli:Depends}
Suggests: gccxml
Description: Mummy CLI bindings
 mummy is a command line executable that generates C# wrappers from gccxml
 output. A C# class is generated to wrap the wrappable class named in the gccxml
 output. Settings to control the wrapping are given inline directly in the class
 header file or in the MummySettings.xml input file.
 .
 CLI bindings to the Kitware.mummy.Runtime library.

Package: mummy-doc
Architecture: all
Depends: ${misc:Depends}, doc-base
Suggests: vtk-doc
Section: doc
Description: mummy class reference documentation
 mummy is a command line executable that generates C# wrappers from gccxml
 output. A C# class is generated to wrap the wrappable class named in the gccxml
 output. Settings to control the wrapping are given inline directly in the class
 header file or in the MummySettings.xml input file.
 .
 This package contains exhaustive HTML documentation for the all the
 documented mummy C++ classes.
