=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
-include /usr/share/dpkg/buildflags.mk

CMAKE_FLAGS += \
	-DMummy_INSTALL_PREFIX:PATH=/usr \
	-DCMAKE_BUILD_TYPE:STRING=RelWithDebInfo \
	-DMUMMY_RUNTIME_UNMANAGED_INSTALL_LIB_DIR:STRING=lib/cli/Kitware.mummy.Runtime-1.0 \
	-DMummy_SNKEYFILE:STRING=/usr/share/cli-common/keys/mono.snk \
	-Dcsc_EXECUTABLE=/usr/bin/mono-csc

# B-D-I is still not quite right on buildd, but anyway let's be prepared:
#ifeq "" "$(filter %-doc,$(shell dh_listpackages))"
#  CMAKE_FLAGS += -DMummy_BUILD_DOCUMENTATION:BOOL=OFF
#else
#  CMAKE_FLAGS += -DMummy_BUILD_DOCUMENTATION:BOOL=ON
#endif

%:
	dh $@ --parallel --with cli

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)

override_dh_installdocs:
	# doxgen create md5 file for bookkeeping do not install them:
	dh_installdocs -X.md5

override_dh_compress:
	# do not compress .map file for doxygen graph
	dh_compress -X.map

debian/mummy.1: debian/mummy.1.in
	help2man --include=debian/mummy.1.in \
		--output=debian/mummy.1 --no-info mummy

get-orig-source:
	./debian/get-orig-source.sh
