## mummy 1.0.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -12,7 +12,7 @@
 #
 SET(Mummy_VERSION_MAJOR 1)
 SET(Mummy_VERSION_MINOR 0)
-SET(Mummy_VERSION_PATCH 2)
+SET(Mummy_VERSION_PATCH 3)
 SET(Mummy_VERSION_STRING "${Mummy_VERSION_MAJOR}.${Mummy_VERSION_MINOR}.${Mummy_VERSION_PATCH}")
 IF(Mummy_BUILD_IS_TOP_LEVEL)
   SET(Mummy_INSTALL_PREFIX "${CMAKE_BINARY_DIR} Install" CACHE STRING "")
