=== Examples/CMakeLists.txt ===
SET(Vehicles_BUILD_TESTING 1)
ADD_SUBDIRECTORY(Vehicles)
