=== debian/changelog ===
mummy (1.0.3-2) unstable; urgency=low

  * Fix ABI version. Closes: #703332
    + debian/libkitware-mummy-runtime1.0-cil.cligacpolicy

 -- Mathieu Malaterre <malat@debian.org>  Mon, 01 Apr 2013 09:33:20 +0200

mummy (1.0.3-1) unstable; urgency=low

  * New upstream
  * Bump Std-Vers to 3.9.4, no changes needed
  * Use dh(9) get hardening for free
  * Refresh patches (use DEP3 when missing)

 -- Mathieu Malaterre <malat@debian.org>  Fri, 15 Mar 2013 14:31:05 +0100
