=== debian/control ===
--- 
+++ 
@@ -3,10 +3,10 @@
 Priority: extra
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Mathieu Malaterre <malat@debian.org>
-Build-Depends: debhelper (>= 8), cmake (>= 2.8.2),
+Build-Depends: debhelper (>= 9), cmake (>= 2.8.2),
  mono-devel, cli-common-dev (>= 0.5.7), libcableswig-dev, libgccxml-dev, libexpat-dev
 Build-Depends-Indep: doxygen (>= 1.6.2), graphviz
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
 Homepage: http://www.kitware.com/products/avdownload.php
 Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/mummy/trunk
 Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/mummy/trunk/
