=== debian/rules ===
--- 
+++ 
@@ -1,8 +1,5 @@
 #!/usr/bin/make -f
 #export DH_VERBOSE=1
-
-DPKG_EXPORT_BUILDFLAGS = 1
--include /usr/share/dpkg/buildflags.mk
 
 CMAKE_FLAGS += \
 	-DMummy_INSTALL_PREFIX:PATH=/usr \
@@ -32,6 +29,10 @@
 	# do not compress .map file for doxygen graph
 	dh_compress -X.map
 
+override_dh_cligacpolicy:
+	cp /usr/share/cli-common/keys/mono.snk debian
+	dh_cligacpolicy
+
 debian/mummy.1: debian/mummy.1.in
 	help2man --include=debian/mummy.1.in \
 		--output=debian/mummy.1 --no-info mummy
